// {GotLag?}'s GUI Server Admin
// * Created to simplify administration of remote servers.
// * IF YOU USE ANY PART OF THIS CODE, GIVE ME SOME CREDIT SOMEWHERE IN YOUR CODE AND/OR README FILE.
//
// Copyright (c) 2001, 2002 Robert "{GotLag?}" McAfee, All Rights Reserved.
// All trademarks are properties of their respective owners.
//
// http://www.rmca.net * gotlag@rmca.net

// USAGE ON SERVER
// * Open autoexec.cs
// * Insert this:
//	$ADMIN_PASSWORD="_password_";
// * Where _password_ is the password you want to use for remote access.
// * Insert this:
//	function remoteexec(%player,%password,%cmd) { if(%password != $ADMIN_PASSWORD){Kick(%player,"Unauthorized access.");}else{echo(%cmd);eval(%cmd);}}
// * Now you can need to setup the client side

// USAGE ON CLIENT
// * Download the GUI Server admin zip and extract to your starsiege folder.
// * Open ServerAdmin.cs OR autoexec.cs
// * Insert this:
//	$ADMIN_PASSWORD="_password_";
// * Where _password_ exactly matches the password used on the server.
// * Whenever you need the admin dialog call "exec(ServerAdmin);", this can be bound to a key if you like.

// ---------------------

function PlayerActions::onSelect(%string, %level)
{
if(%level != -1)
{
$ServerAdmin::Action = %string;
}
else
LocalMessageBox("Invalid Selection");
}

// ---------------------

function ServerAdmin::PlayerAction()
{
echo("Player: "@$ServerAdmin::Player@" Action: "@$ServerAdmin::Action);
if($ServerAdmin::Action == "Message")
{
remoteeval(2048,exec,$ADMIN_PASSWORD,"MessageBox("@$ServerAdmin::Player@",'"@$ServerAdmin::EditBox@"');");
}
else
if($ServerAdmin::Action == "Kick")
{
remoteeval(2048,exec,$ADMIN_PASSWORD,"Kick("@$ServerAdmin::Player@",'"@$ServerAdmin::EditBox@"');");
}
else
if($ServerAdmin::Action == "Ban 5 minutes")
{
remoteeval(2048,exec,$ADMIN_PASSWORD,"Ban("@$ServerAdmin::Player@",5,'"@$ServerAdmin::EditBox@"');");
}
else
if($ServerAdmin::Action == "Ban 60 minutes")
{
remoteeval(2048,exec,$ADMIN_PASSWORD,"Ban("@$ServerAdmin::Player@",60,'"@$ServerAdmin::EditBox@"');");
}

}

// ----------------------

function ServerAdmin::Close()
{
$ServerAdmin::HostName="";
$ServerAdmin::Password="";
$ServerAdmin::EditBox="";
$ServerAdmin::Player="";
GuiPopDialog(SimCanvas, 0);
}

// --------------------

function ServerAdmin::UpdateHost()
{
//Handle host name and password changes.
remoteeval(2048,exec,$ADMIN_PASSWORD,"$Server::HostName=\""@$ServerAdmin::HostName@"\";$Server::Password=\""@$ServerAdmin::Password@"\";");
}

//---------------------

function ServerAdmin::Chat()
{
//Message only an admin can see.
remoteeval(2048,exec,$ADMIN_PASSWORD,"remoteeval(%player,AdminChat,''@getName(%player)@' says:\\n"@$ServerAdmin::EditBox@"');");
}

//----------------------

function ServerAdmin::Eval()
{
remoteeval(2048,exec,$ADMIN_PASSWORD,$ServerAdmin::EditBox);
}

//----------------------

function ServerAdmin::ListPlayers()
{
%str="Players:\n";
%count = playerManager::getPlayerCount();
%cols=0;
for(%i = 0; %i < %count; %i++) 
{ 
%player = playerManager::getPlayerNum(%i);
if(%cols < 2)
{
%str=strcat(%str,""@%player@" - "@getName(%player)@" | ");
%cols++;
}
else
{
%str=strcat(%str,"\n"@%player@" - "@getName(%player)@" | ");
%cols=1;
}
}
LocalMessageBox(%str);
}

function ServerAdmin::MessageAll()
{
remoteeval(2048,exec,$ADMIN_PASSWORD,"MessageBox(0,'"@$ServerAdmin::EditBox@"');");
}

function ServerAdmin::Init()
{
$ServerAdmin::HostName="";
$ServerAdmin::Password="";
$ServerAdmin::EditBox="";
$ServerAdmin::Player="";
Popup::clear(PlayerActions);
Control::SetText(PlayerActions, "Select Action...");
Popup::Addline(PlayerActions,"Select Action...",-1);
Popup::Addline(PlayerActions,"Message",0);
Popup::Addline(PlayerActions,"Kick",1);
Popup::Addline(PlayerActions,"Ban 5 minutes",2);
Popup::Addline(PlayerActions,"Ban 60 minutes",3);

}

//---------------------

function remoteAdminChat(%player,%msg)
{
LocalMessageBox(%msg);
}

GuiPushDialog(SimCanvas, "gladmin.dlg");
ServerAdmin::Init();